#include <pspkernel.h>
#include <pspctrl.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <psppower.h>
#include <stdio.h>
#include <stdlib.h>
#include <pspkernel.h>
#include <pspctrl.h>
#include <psppower.h>
#include <pspdebug.h>
#include <psprtc.h>
#include <pspsdk.h>
#include <pspaudiocodec.h>
#include <pspaudio.h>
#include <string.h>
#include <malloc.h>

#include "file.h"

int SetupCallbacks();

PSP_MODULE_INFO("AT3 decodeTest", 0x1000, 1, 1);
PSP_MAIN_THREAD_ATTR(0);

#define printf    pspDebugScreenPrintf

FileList filelist;
int x;

__attribute__ ((constructor))
void loaderInit(){
   pspKernelSetKernelPC();
   pspSdkInstallNoDeviceCheckPatch();
   pspSdkInstallNoPlainModuleCheckPatch();
   pspSdkInstallKernelLoadModulePatch();
}

SceCtrlData input;

#define TYPE_ATRAC3 0x270
#define TYPE_ATRAC3PLUS 0xFFFE

unsigned long at3_codec_buffer[65] __attribute__((aligned(64)));
short at3_mix_buffer[2048 * 2] __attribute__((aligned(64)));

//char filename_in[1024], filename_out[1024];
int filecount=1, filesize, header, offset;

unsigned char waveheader[] = {0x52, 0x49, 0x46, 0x46, 0x00, 0x00, 0x00, 0x00, 0x57, 0x41, 0x56, 0x45, 0x66, 0x6D, 0x74, 0x20,
0x10, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x44, 0xAC, 0x00, 0x00, 0x10, 0xB1, 0x02, 0x00,
0x04, 0x00, 0x10, 0x00, 0x64, 0x61, 0x74, 0x61, 0x00, 0x00, 0x00, 0x00};

SceUID at3_handle;
u16 at3_type;
u8* at3_data_buffer;
u16 at3_data_align;
u32 at3_sample_per_frame;
u16 at3_channel_mode;
u8 at3_at3plus_flagdata[2];
u32 at3_data_start;
u32 at3_data_size;
u8 at3_getEDRAM;
u32 at3_channels;
u32 at3_samplerate;


int main(void)
{
   pspDebugScreenInit();
   char friendlyname1[255];
   char friendlyname2[255];
   char friendlyname3[255];
   SetupCallbacks();

   int result = pspSdkLoadStartModule("flash0:/kd/audiocodec.prx", PSP_MEMORY_PARTITION_KERNEL);
   pspSdkFixupImports(result);

   if (!(fileGetList("ms0:/at3/", NULL, FILE_LIST_FILE | FILE_LIST_RECURSIVE,&filelist)))
   {
      x = 0;
      while (x < filelist.count) {
//       if (strcmp(filelist.list[x], "ms0:/rco/SYSMEM.PRX") == 0) { x++; }

//       turn filename (e.g. ms0:/enc/audio.prx) into file (e.g. audio.prx)
         sprintf(friendlyname1, "%s", filelist.list[x]);
         char delims[1] = "/";
         int toknumber = 1;
         char *result = NULL;
         result = strtok(friendlyname1, delims);
         while(result != NULL) {
            if (toknumber >= 3) { sprintf(friendlyname2, "%s", result); }
            result = strtok(NULL, delims);
            toknumber++;
         }
         sprintf(friendlyname3, "%s%s%s", "ms0:/", friendlyname2, ".wav");
//repeat:
   header = 0;
//   sprintf(filename_in, "ms0:%02d.at3", filecount);
   SceUID at3_handle = sceIoOpen(filelist.list[x], PSP_O_RDONLY, 0777);
   if ( !at3_handle )
   {
//	  printf("Failed to open %s", filelist.list[x]);
      goto nextfile;
   }

   u32 riff_header[2];
   riff_header[0] = 0;
   riff_header[1] = 0;
   if ( sceIoRead( at3_handle, riff_header, 8 ) != 8 )
   {
//	  printf("Failed to read header");
      goto nextfile;
   }
   if ( ((riff_header[0] & 0xFFFF) == 0x0000D00F) && (riff_header[1] == 0x00000000) )
   {
      u32 tempstorage[512];
      memset(tempstorage, 0, 2048);
      filesize = sceIoRead( at3_handle, tempstorage, 2048);
      if ( filesize >= 12 )
      {
         offset = 0;
         do {
            if ( (riff_header[0] == tempstorage[offset]) && (riff_header[1] == tempstorage[offset+1]) )
            {
//               printf("Identified file as raw at3...\n");
               at3_type = 0xFFFE;
               at3_channels = 0x0002;
               at3_samplerate = 0x0000AC44;
               at3_data_align = offset << 2;
               at3_at3plus_flagdata[0] = riff_header[0] >> 16;
               at3_at3plus_flagdata[1] = riff_header[0] >> 24;
               at3_data_size = sceIoLseek32(at3_handle, 0, PSP_SEEK_END);
               sceIoLseek32(at3_handle, 0, PSP_SEEK_SET);
//               printf("Skipping RIFF-parsing...\n");
               goto skipRIFF;
            }
            offset++;
         } while (offset <= ((filesize-8) >> 2));
      }
//      printf("Failed to identify file");
      goto nextfile;
   }

   if ( riff_header[0] != 0x46464952 )
   {
//	  printf("Failed to identify RIFF-header");
      goto nextfile;
   }
   u32 wavefmt_header[3];
   wavefmt_header[0] = 0;
   wavefmt_header[1] = 0;
   wavefmt_header[2] = 0;
   if ( sceIoRead( at3_handle, wavefmt_header, 12 ) != 12 )
   {
//	  printf("Failed to read wavefmt-header");
      goto nextfile;
   }
   if ( wavefmt_header[0] != 0x45564157 || wavefmt_header[1] != 0x20746D66 )
   {
//	  printf("Failed to identify wavefmt-header");
      goto nextfile;
   }
   u8* wavefmt_data = (u8*)malloc(wavefmt_header[2]);
   if ( wavefmt_data == NULL )
   {
//	  printf("Failed to allocate wavedata");
      goto nextfile;
   }
   if ( sceIoRead( at3_handle, wavefmt_data, wavefmt_header[2] ) != wavefmt_header[2] ) {
      free(wavefmt_data);
//	  printf("Failed to read wavedata");
      goto nextfile;
   }
   at3_type = *((u16*)wavefmt_data);
   at3_channels = *((u16*)(wavefmt_data+2));
   at3_samplerate = *((u32*)(wavefmt_data+4));
   at3_data_align = *((u16*)(wavefmt_data+12));
   waveheader[0x18] = at3_samplerate;
   waveheader[0x19] = at3_samplerate >> 8;
   waveheader[0x1A] = at3_samplerate >> 16;
   waveheader[0x1B] = at3_samplerate >> 24;

   if ( at3_type == TYPE_ATRAC3PLUS) {
      at3_at3plus_flagdata[0] = wavefmt_data[42];
      at3_at3plus_flagdata[1] = wavefmt_data[43];
   }

   free(wavefmt_data);

   u32 data_header[2];
   data_header[0] = 0;
   data_header[1] = 0;
   if ( sceIoRead( at3_handle, data_header, 8 ) != 8 )
   {
//	  printf("Failed to read data-header");
      goto nextfile;
   }
   while(data_header[0] != 0x61746164 ) {
      sceIoLseek32(at3_handle, data_header[1], PSP_SEEK_CUR);
      if ( sceIoRead( at3_handle, data_header, 8 ) != 8 )
      {
//	     printf("Failed to locate data-header");
         goto nextfile;
      }
   }

   at3_data_start = sceIoLseek32(at3_handle, 0, PSP_SEEK_CUR);
   at3_data_size = data_header[1];
skipRIFF:
   if ( at3_data_size % at3_data_align != 0 )
   {
      if ( at3_data_size % (at3_data_align+8) != 0 )
      {
//         printf("Alignment failed");
         goto nextfile;
      }
      else
      {
         header=1;
      }
   }

   memset(at3_codec_buffer, 0, sizeof(at3_codec_buffer));
//   printf("Checking AT3-type\n");

   if ( at3_type == TYPE_ATRAC3 ) {
      at3_channel_mode = 0x0;
      if ( at3_data_align == 0xC0 ) // atract3 have 3 bitrate, 132k,105k,66k, 132k align=0x180, 105k align = 0x130, 66k align = 0xc0
         at3_channel_mode = 0x1;
      at3_sample_per_frame = 1024;
      at3_data_buffer = (u8*)memalign(64, 0x180);
      if ( at3_data_buffer == NULL)
      {
//         printf("Failed to allocate buffer");
         goto wait;
      }
      at3_codec_buffer[26] = 0x20;
      if ( sceAudiocodecCheckNeedMem(at3_codec_buffer, 0x1001) < 0 )
      {
//         printf("Failed to check buffer");
         goto wait;
      }
      if ( sceAudiocodecGetEDRAM(at3_codec_buffer, 0x1001) < 0 )
      {
//         printf("Failed to get buffer");
         goto wait;
      }
      at3_getEDRAM = 1;
      at3_codec_buffer[10] = 4;
      at3_codec_buffer[44] = 2;
      if ( at3_data_align == 0x130 )
         at3_codec_buffer[10] = 6;
      if ( sceAudiocodecInit(at3_codec_buffer, 0x1001) < 0 )
      {
//         printf("Failed to init");
         goto wait;
      }
   }
   else if ( at3_type == TYPE_ATRAC3PLUS ) {
      at3_sample_per_frame = 2048;
      int temp_size = at3_data_align+8;
      int mod_64 = temp_size & 0x3f;
      if (mod_64 != 0) temp_size += 64 - mod_64;
      at3_data_buffer = (u8*)memalign(64, temp_size);
      if ( at3_data_buffer == NULL)
      {
//         printf("Failed to allocate buffer");
         goto wait;
      }
      at3_codec_buffer[5] = 0x1;
      at3_codec_buffer[10] = at3_at3plus_flagdata[1];
      at3_codec_buffer[10] = (at3_codec_buffer[10] << 8 ) | at3_at3plus_flagdata[0];
      at3_codec_buffer[12] = 0x1;
      at3_codec_buffer[14] = 0x1;
      if ( sceAudiocodecCheckNeedMem(at3_codec_buffer, 0x1000) < 0 )
      {
//         printf("Failed to check buffer");
         goto wait;
      }
      if ( sceAudiocodecGetEDRAM(at3_codec_buffer, 0x1000) < 0 )
      {
//         printf("Failed to get buffer");
         goto wait;
      }
      at3_getEDRAM = 1;
      if ( sceAudiocodecInit(at3_codec_buffer, 0x1000) < 0 )
      {
//         printf("Failed to init");
         goto wait;
      }
   }
   else
      goto wait;

   filesize = 0;
//   sprintf(filename_out, "ms0:%02d.wav", filecount++);
   SceUID fd = sceIoOpen(friendlyname3, PSP_O_CREAT | PSP_O_TRUNC | PSP_O_WRONLY, 0777);
   sceIoWrite(fd, waveheader, sizeof(waveheader));
   printf("Decompressing %s... ", friendlyname2);
//   printf("Reading sampledata\n");
   int eof = 0;
   while( !eof ) {
      int samplesdecoded;
      memset(at3_mix_buffer, 0, 2048*2*2);
      unsigned long decode_type = 0x1001;
      if ( at3_type == TYPE_ATRAC3 )
      {
         memset( at3_data_buffer, 0, 0x180);
         if (sceIoRead( at3_handle, at3_data_buffer, at3_data_align ) != at3_data_align) {
            eof = 1;
            continue;
         }
         if ( at3_channel_mode )
         {
            memcpy(at3_data_buffer+at3_data_align, at3_data_buffer, at3_data_align);
         }
         decode_type = 0x1001;
      }
      else
      {
         if ( !header )
         {
            memset( at3_data_buffer, 0, at3_data_align+8);
            at3_data_buffer[0] = 0x0F;
            at3_data_buffer[1] = 0xD0;
            at3_data_buffer[2] = at3_at3plus_flagdata[0];
            at3_data_buffer[3] = at3_at3plus_flagdata[1];
            if (sceIoRead( at3_handle, at3_data_buffer+8, at3_data_align ) != at3_data_align) {
               eof = 1;
               continue;
            }
         }
         else
         {
            memset( at3_data_buffer, 0, at3_data_align+8);
            if (sceIoRead( at3_handle, at3_data_buffer, at3_data_align+8 ) != at3_data_align+8) {
               eof = 1;
               continue;
            }
         }
         decode_type = 0x1000;
      }

      at3_codec_buffer[6] = (unsigned long)at3_data_buffer;
      at3_codec_buffer[8] = (unsigned long)at3_mix_buffer;

      int res = sceAudiocodecDecode(at3_codec_buffer, decode_type);
//      printf("%d\n", res);
      if ( res < 0 ) {
         eof = 1;
         continue;
      }
      sceIoWrite(fd, at3_mix_buffer, sizeof(at3_mix_buffer));
      filesize = filesize + sizeof(at3_mix_buffer);
      samplesdecoded = at3_sample_per_frame;
   }
   waveheader[4] = filesize+36;
   waveheader[5] = (filesize+36) >> 8;
   waveheader[6] = (filesize+36) >> 16;
   waveheader[7] = (filesize+36) >> 24;
   waveheader[40] = filesize;
   waveheader[41] = filesize >> 8;
   waveheader[42] = filesize >> 16;
   waveheader[43] = filesize >> 24;
   sceIoLseek32(fd, 4, PSP_SEEK_SET);
   sceIoWrite(fd, waveheader+4, 4);
   sceIoLseek32(fd, 40, PSP_SEEK_SET);
   sceIoWrite(fd, waveheader+40, 4);
   sceIoClose(fd);
   printf("Done\n");
   sceIoClose(at3_handle);
   at3_handle = 0;
   free(at3_data_buffer);
   at3_data_buffer = 0;
   sceAudiocodecReleaseEDRAM(at3_codec_buffer);
   at3_getEDRAM = 0;
//   goto repeat;
nextfile:
   if ( at3_handle ) {
      sceIoClose(at3_handle);
   }
         x++;
      }
      fileFreeList(&filelist);
   }
   goto done;

wait:
   fileFreeList(&filelist);
done:
   if ( at3_handle ) {
      sceIoClose(at3_handle);
   }
   if ( at3_data_buffer) {
      free(at3_data_buffer);
   }
   if ( at3_getEDRAM ) {
      sceAudiocodecReleaseEDRAM(at3_codec_buffer);
   }

   printf("\n\nPress TRIANGLE to quit.\n");
   sceCtrlReadBufferPositive(&input, 1);
   while(!(input.Buttons & PSP_CTRL_TRIANGLE))
   {
      sceKernelDelayThread(10000);   // wait 10 milliseconds
      sceCtrlReadBufferPositive(&input, 1);
   }

   sceKernelExitGame();
   return 0;
}


/* Exit callback */
int exit_callback(int arg1, int arg2, void *common)
{
   sceKernelExitGame();
   return 0;
}


/* Callback thread */
int CallbackThread(SceSize args, void *argp)
{
   int cbid;

   cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
   sceKernelRegisterExitCallback(cbid);

   sceKernelSleepThreadCB();

   return 0;
}


/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void)
{
   int thid = 0;

   thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
   if(thid >= 0)
   {
      sceKernelStartThread(thid, 0, 0);
   }

   return thid;
}
